class ApplicationController < ActionController::Base
  helper Openseadragon::OpenseadragonHelper
  # Adds a few additional behaviors into the application controller
  include Blacklight::Controller
  include Hydra::Controller::ControllerBehavior

  # Adds Hyrax behaviors into the application controller
  include Hyrax::Controller
  include Hyrax::ThemedLayoutController
  with_themed_layout '1_column'
  before_action :check_agreement_acceptance

  private

  def check_agreement_acceptance
    if current_user.present? && !current_user.agreement_accepted?
      redirect_to main_app.deposite_agreement_path 
    end
  end
end
