# frozen_string_literal: true

# Generated via
#  `rails generate hyrax:work_resource Dataset`
module Hyrax
  # Generated controller for Dataset
  class DatasetsController < ApplicationController
    # Adds Hyrax behaviors to the controller.
    include Hyrax::WorksControllerBehavior
    include Hyrax::BreadcrumbsForWorks
    self.curation_concern_type = ::Dataset

    # Use this line if you want to use a custom presenter
    self.show_presenter = Hyrax::DatasetPresenter

    # Use a Valkyrie aware form service to generate Valkyrie::ChangeSet style
    # forms.
    self.work_form_service = Hyrax::FormFactory.new

    before_action :check_tombstone, only: [:show, :edit]

    private

    def check_tombstone
      @dataset =  Dataset.find(params[:id])

      if current_user.nil?
        if @dataset.is_tombstoned == true
          flash[:notice] = 'The work (dataset) is not available because it has Tombstoned'
          render 'shared/tombstone', locals: {work: @dataset}, status: :unauthorized
        end
      elsif current_user.admin? || current_user.is_depositor_for?(@dataset)
        if @dataset.is_tombstoned == true && params[:action] == 'edit'
          redirect_to main_app.polymorphic_path(@dataset)
        end
      else
        if @dataset.is_tombstoned == true
          flash[:notice] = 'The work (dataset) is not available because it has Tombstoned'
          render 'shared/tombstone', locals: {work: @dataset}, status: :unauthorized
        end
      end
    end
  end
end
