# frozen_string_literal: true

# Generated via
#  `rails generate hyrax:work_resource Crc1280Experiment`
#
# @see https://github.com/samvera/hyrax/wiki/Hyrax-Valkyrie-Usage-Guide#forms
# @see https://github.com/samvera/valkyrie/wiki/ChangeSets-and-Dirty-Tracking
class Crc1280ExperimentForm < Hyrax::Forms::PcdmObjectForm(Crc1280Experiment)
  property :complex_person, primary: true, required: true, populator: :complex_person_populator
  property :complex_date, populator: :complex_date_populator
  property :complex_identifier, populator: :complex_identifier_populator   
  property :complex_funding_reference, populator: :complex_funding_reference_populator, prepopulator: :complex_funding_reference_prepopulator 
  property :complex_relation, populator: :complex_relation_populator

  include Hyrax::FormFields(:basic_metadata)
  include Hyrax::FormFields(:crc1280_experiment)
  include PopulatorBehavior

  self.required_fields -= [:creator]
  self.required_fields = [
    # Adding all required fields in order of display in form
    :title, :complex_person, :description, :resource_type, :keyword , :experiment_description,:crc_resource_type,
    :coverage,
  ]

  def tabs
    %w[metadata files relationships]
  end

  def primary_terms
    [
      # Fields to be displayed above fold
      :title,
      :experiment_description,
      :complex_person,
      :crc_resource_type,
      :coverage,
      :keyword,
      :license,
      :approval_number,
      :complex_funding_reference,
      :extra_information,
      :crc_work_type
    ]
  end

  def secondary_terms
    [
      :complex_relation,
    ]
  end
end
