module ComplexField
  module ModalityIndexer
    def to_solr
      super.tap do |index_document|
        index_modality(index_document)
      end
    end

    def index_modality(index_document)
      complex_sessions = resource.complex_subjects.map{|subject| subject.complex_sessions}.flatten
      complex_modalities = complex_sessions.map{|session| session.complex_modalities}.flatten
      
      index_document["complex_modality_ssm"] = complex_modalities.to_json
      complex_modalities.each do |c|
        # modality_titles
        # vals = c.modality_title
        # fld_name = "modality_title_tesim"
        # index_document[fld_name] = [] unless index_document.include?(fld_name)
        # index_document[fld_name] << vals
        # index_document[fld_name] = index_document[fld_name].flatten.uniq
        # fld_name = "modality_title_sim"
        # index_document[fld_name] = [] unless index_document.include?(fld_name)
        # index_document[fld_name] << vals
        # index_document[fld_name] = index_document[fld_name].flatten.uniq

        # modalities
        vals = c.modality
        fld_name = "modality_tesim"
        index_document[fld_name] = [] unless index_document.include?(fld_name)
        index_document[fld_name] << vals
        index_document[fld_name] = index_document[fld_name].flatten.uniq
        fld_name = "modality_sim"
        index_document[fld_name] = [] unless index_document.include?(fld_name)
        index_document[fld_name] << vals
        index_document[fld_name] = index_document[fld_name].flatten.uniq
      end
    end

    def self.modality_facet_fields
      # solr fields that will be treated as facets
      fields = []
      # fields << "modality_title_sim"
      fields << "modality_sim"
      fields
    end

    def self.modality_search_fields
      # solr fields that will be used for a search
      fields = []
      # fields << "modality_title_tesim"
      fields << "modality_tesim"
      fields
    end

    def self.modality_show_fields
      # solr fields that will be used to display results on the record page
      fields = []
      fields << "complex_modality_ssm"
      fields
    end
  end
end
