# frozen_string_literal: true

# Generated via
#  `rails generate hyrax:work_resource Crc1280Experiment`
class Crc1280ExperimentIndexer < Hyrax::Indexers::PcdmObjectIndexer(Crc1280Experiment)
  include Hyrax::Indexer(:basic_metadata)
  include Hyrax::Indexer(:crc1280_experiment)
  include Hyrax::IndexesWorkflow
  # Custom indexers for crc dataset model
  include ComplexField::PersonIndexer
  include ComplexField::DateIndexer
  include ComplexField::IdentifierIndexer
  include ComplexField::FundrefIndexer
  include ComplexField::RelationIndexer
  include ComplexField::SubjectIndexer
  include ComplexField::SessionIndexer
  include ComplexField::ModalityIndexer

  # Uncomment this block if you want to add custom indexing behavior:
  def to_solr
    super.tap do |index_document|
      index_document[:title_anssort] = resource.title[0]
      index_document[:member_of_collections_ssim] = resource.parent_collections&.first&.title if resource.persisted?
    end
  end


  def self.facet_fields
    # solr fields that will be treated as facets
    super.tap do |fields|
      # fields << "crc_work_type_sim"
      fields << "modality_sim"
      fields << "crc_resource_type_sim"
      fields << "coverage_sim"
      fields.concat ComplexField::IdentifierIndexer.identifier_facet_fields
      fields.concat ComplexField::DateIndexer.date_facet_fields
      fields.concat ComplexField::PersonIndexer.person_facet_fields
      fields.concat ComplexField::FundrefIndexer.fundref_facet_fields
      fields.concat ComplexField::SubjectIndexer.subject_facet_fields
      fields.concat ComplexField::SessionIndexer.session_facet_fields
      fields.concat ComplexField::ModalityIndexer.modality_facet_fields
    end
  end

  def self.search_fields  
    # solr fields that will be used for a search
    super.tap do |fields|
      fields << "crc_work_type_tesim"
      fields << "modality_tesim"
      fields << "crc_resource_typarchable_tesim"
      fields << "coverage_tesim"
      fields << "files_size_tesim"
      fields.concat ComplexField::IdentifierIndexer.identifier_search_fields
      fields.concat ComplexField::DateIndexer.date_search_fields
      fields.concat ComplexField::PersonIndexer.person_search_fields
      fields.concat ComplexField::FundrefIndexer.fundref_search_fields
      fields.concat ComplexField::SubjectIndexer.subject_search_fields
      fields.concat ComplexField::SessionIndexer.session_search_fields
      fields.concat ComplexField::ModalityIndexer.modality_search_fields
    end
  end

  def self.show_fields
    # solr fields that will be used to display results on the record page
    super.tap do |fields|
      fields << "crc_work_type_tesim"
      fields << "modality_tesim"
      fields << "crc_resource_type_tesim"
      fields << "coverage_tesim"
      fields << "files_size_tesim"
      fields.concat ComplexField::IdentifierIndexer.identifier_show_fields
      fields.concat ComplexField::DateIndexer.date_show_fields
      fields.concat ComplexField::PersonIndexer.person_show_fields
      fields.concat ComplexField::FundrefIndexer.fundref_show_fields
      fields.concat ComplexField::SubjectIndexer.subject_show_fields
      fields.concat ComplexField::SessionIndexer.session_show_fields
      fields.concat ComplexField::ModalityIndexer.modality_show_fields
    end
  end
end
