class CrcFileSetIndexer < Hyrax::FileSetIndexer
  def self.facet_fields
    # solr fields that will be treated as facets
    super.tap do |fields|
      fields["for_complex_identifier_sim"] = resource.for_complex_identifier
      fields["for_complex_type_sim"] = resource.for_complex_type
    end
  end

  def self.search_fields
    # solr fields that will be used for a search
    super.tap do |fields|
      fields["for_complex_identifier_tesim"] = resource.for_complex_identifier
      fields["for_complex_type_tesim"] = resource.for_complex_type
    end
  end

  def self.show_fields
    # solr fields that will be used to display results on the record page
    super.tap do |fields|
      fields["for_complex_identifier_tesim"] = resource.for_complex_identifier
      fields["for_complex_type_tesim"] = resource.for_complex_type
    end
  end
end