# frozen_string_literal: true

# Generated via
#  `rails generate hyrax:work_resource Crc1280Experiment`
class Crc1280Experiment < Hyrax::Work
  attribute :complex_person , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_funding_reference , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_relation , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_date , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  attribute :complex_identifier , Valkyrie::Types::Array.of(Valkyrie::Types::String)
  include Hyrax::Schema(:basic_metadata)
  include Hyrax::Schema(:crc1280_experiment)
  include CommonQuery
  include ::Hyrax::TombstoneBehavior
  include ExternalServices
  include S3FileHandleable

  CRC_FILTER_FACET_FIELDS = [
    "year_recorded_sim",
    "complex_subject_species_sim",
    "complex_subject_type_sim",
    "complex_subject_sex_sim",
    "complex_subject_age_itsim",
    "session_sim",
    "modality_sim"
  ]

  CRC_FACET_FIELDS = [
    "complex_identifier_group_id_sim",
    "coverage_sim",
    "crc_resource_type_sim"
  ] + CRC_FILTER_FACET_FIELDS

  def default_admin_set
    AdminSetHelper.find_by(title: [ENV.fetch('CRC_ADMIN_SET_TITLE', 'CRC 1280 Publishing Workflow')])
  end

  def file_sets
    @file_sets ||= Hyrax::FileSet.where(for_complex_type: ["Crc1280Experiment"], for_complex_identifier: self.source)
  end

  def complex_subjects
    ComplexSubject.where(parent_source_identifier: source.first)
  end

  def complex_sessions
    complex_subjects.map(&:complex_sessions)
  end

  def complex_modalities
    complex_subjects.map(&:complex_modalities)
  end

  def apply_parent_permissions
    parent = self.parent_collections.first
    if parent.present?
      template = Hyrax::PermissionTemplate.find_by(source_id: parent.id.to_s)
      self.edit_groups += template.agent_ids_for(agent_type: 'group', access: 'manage')
      self.edit_users  += template.agent_ids_for(agent_type: 'user',  access: 'manage')
      self.read_groups += template.agent_ids_for(agent_type: 'group', access: 'view')
      self.read_users  += template.agent_ids_for(agent_type: 'user',  access: 'view')
    end

    self
  end
end
