# frozen_string_literal: true

module Hyrax
  module Workflow
    module ChangesRequired
      class GroupManagerNotification < AbstractNotification
        private

        def subject
          I18n.t('hyrax.notifications.workflow.changes_required.subject')
        end

        def message
          I18n.t('hyrax.notifications.workflow.changes_required.message',
                title: title,
                link: (link_to work_id, document_path),
                comment: comment)
        end

        def users_to_notify
          [::User.find_by(email: @entity.proxy_for.depositor)]
        end
      end
    end
  end
end
