# config/initializers/hyrax_downloader_override.rb
require 'hyrax/controlled_vocabulary/importer/downloader'

Rails.application.config.to_prepare do
  Hyrax::ControlledVocabulary::Importer::Downloader.class_eval do
    class << self
      def fetch(url, output)
        URI.open(url) do |io|
          IO.copy_stream(io, output)
        end
      rescue OpenURI::HTTPError => e
        raise "Unable to download from #{url}\n#{e.message}: #{e.io.read}"
      end
    end
  end
end
