namespace :rdms do
  desc 'Add users to RDMS. usage: rdms:setup_users["users.json", "false"]'
  task :setup_users, [:seedfile, :update_users] => :environment do |task, args|

    seedfile = args.seedfile
    update_user = args.update_users
    if update_user.is_a? String
      if update_user.downcase == 'false'
        update_user = false
      else
        update_user = true
      end
    end
    
    if (File.exist?(seedfile))
      puts("Running task to add / update users from seedfile: #{seedfile}")
    else
      abort("ERROR: missing seedfile for user setup: #{seedfile}")
    end

    seed = JSON.parse(File.read(seedfile))

    seed.fetch('users', []).each_with_index do |parsed_user, index|
      user_count = index + 1
      puts "--- User: #{user_count} ---"
      _success, messages, _user = User.create_user_from_hash(parsed_user, update_user: update_user)
      puts messages if messages.any?
    end
  end

end

# Example json file
# {
#   "users":
#   [{
#     "email": "example_user@hyrax",
#     "password": "password",
#     "name": "Example User",
#     "saml_id": "urn:oasis:names:tc:SAML:attribute:pairwise-id",
#      "orcid": "orcid id",
#     "role": "crc_1280_group_manager",
#     group_id: "vd66vz88c"
#   }]
# }
